import groovy.lang.GroovyClassLoader;
import groovy.lang.GroovyObject;
import java.io.File;

/* groovy ReadConfigNetworkJson.groovy

Within groovy script : the reference passed as parameter
Server N150:8900
Node   localhost:8910
Node   localhost:8911
Within groovy script : the reference returned by the function
Server N150:8900
Node   localhost:8910
Node   localhost:8911
*/

// javac -cp .:/home/amos/bin/groovy-2.4.6/embeddable/groovy-all-2.4.6.jar ReadConfigNetworkExample.java

/* java -cp .:/home/amos/bin/groovy-2.4.6/embeddable/groovy-all-2.4.6.jar ReadConfigNetworkExample

Within Java : the input parameter
Server N150:8900
Node   localhost:8910
Node   localhost:8911
Within Java : the return value
Server N150:8900
Node   localhost:8910
Node   localhost:8911
Returned by Groovy : N150:8900
*/
public class ReadConfigNetworkExample {

  public static CIConfigNetwork readConfigNetwork(CIConfigNetwork cicn) throws Exception {

    final GroovyClassLoader classLoader = new GroovyClassLoader();

    Class groovy = classLoader.parseClass(new File("ReadConfigNetworkJson.groovy"));
    GroovyObject groovyObj = (GroovyObject)groovy.newInstance();

    CIConfigNetwork rv = (CIConfigNetwork)groovyObj.invokeMethod("runScript", new Object[] {cicn});

    System.out.println("Within Java : the input parameter");
    groovyObj.invokeMethod("printConfigNetwork", new Object[] {cicn});

    System.out.println("Within Java : the return value");
    groovyObj.invokeMethod("printConfigNetwork", new Object[] {rv});

    return rv;
  }

  public static void main(final String[] args) throws Exception {

    CIConfigNetwork cicn = new CIConfigNetwork();
    CIConfigNetwork rv = readConfigNetwork(cicn);
    System.out.println("Returned by Groovy : " + rv.myName + ":" + rv.myPort);
  }
}
