import groovy.json.JsonSlurper
import CIConfigNetwork

/* groovy ReadConfigNetworkJson.groovy

Within groovy script : the reference passed as parameter
Server N150:8900
Node   localhost:8910
Node   localhost:8911
Within groovy script : the reference returned by the function
Server N150:8900
Node   localhost:8910
Node   localhost:8911
*/

CIConfigNetwork runScript(CIConfigNetwork input) {
  String inputString = new File("configNetwork.json").text

  JsonSlurper jsonSlurper = new JsonSlurper()

  Map jsonResult = (Map)jsonSlurper.parseText(inputString)

  input.myName = jsonResult['myName']
  input.myPort = jsonResult['myPort']

  List nodes = (List)jsonResult['nodeList']

  for (node in nodes) {
    Map m = (Map)node
    CIPair<String, String> pair = new CIPair<String, String>()
    pair.leftValue = m.get("IP")
    pair.rightValue = m.get("Port")
    input.nodeList.add(pair)
  }

  return input
}

def printConfigNetwork(CIConfigNetwork cicn) {
  println "Server " + cicn.myName + ":" + cicn.myPort
  for (node in cicn.nodeList) {
    println "Node   " + node.leftValue + ":" + node.rightValue
  }
}

CIConfigNetwork cicn = new CIConfigNetwork()
CIConfigNetwork cicnOut = runScript(cicn)
println "Within groovy script : the reference passed as parameter"
printConfigNetwork(cicn)

println "Within groovy script : the reference returned by the function"
printConfigNetwork(cicnOut)
